10    CLS
20    REM
30    PRINT :PRINT :PRINT :PRINT
40    PRINT  TAB(29) "AN ASTRONOMY PROGRAM"
45    PRINT  : PRINT
50    PRINT  TAB(18) "###### TIME, ALTITUDE & AZIMUTH ,J.D. ###### "
55    PRINT  : PRINT
60    PRINT  TAB(30) " BY CHRIS SPRATT"
65    PRINT
70    PRINT  TAB(34) "SEPT 1984"
75    PRINT
80    PRINT  : PRINT : LOCATE 24,25
85    PRINT "PRESS ANY KEY TO CONTINUE"
90    IF INKEY$ = "" THEN 90
95    CLS : PRINT  : PRINT :PRINT :PRINT
100   REM   ALTITUDE AND AZIMUTH
110   REM
120      P = 3.14159265#: R1 = P/180
130      GOTO 490
131     PRINT
135     PRINT: PRINT TAB(20) "OBJECT OF INTEREST'S"
136     PRINT :
140      PRINT TAB(20) : INPUT  "R A (H,M,S) ";A$,A2,A3 : PRINT
150      GOSUB 400: R = A*15 * R1
160      PRINT TAB(20):  INPUT  "DEC (D,M,S) ";A$,A2,A3 :PRINT
170      GOSUB 400: D = A*R1
180      PRINT TAB(20) : INPUT  "LAT, LONG   ";B,L : PRINT
190      B = B*R1: L = L*R1
196      T = ST*15 *R1
200      T5 = T-R+L:  REM LHA
210      S1 = SIN(B)*SIN(D)
220      S1 = S1+COS(B)*COS(D)*COS(T5)
230      C1 = 1 -S1*S1
240      IF C1>0 THEN C1 =SQR(C1)
250       IF C1 <=0 THEN 270
260       H = ATN(S1/C1): GOTO 280
270       H = SGN(S1) * P/2
280       C2 = COS(B) * SIN(D)
290       C2 = C2 - SIN(B)* COS(D) * COS(T5)
300       S2 = -COS(D)*SIN(T5)
310       IF C2 = 0 THEN A = SGN(S2) * P/2
320       IF C2 = 0 THEN 350
330       A = ATN(S2/C2)
340       IF C2 < 0 THEN A = A+P
350       IF A < 0 THEN A = A+2*P
360       PRINT :PRINT TAB(20) "OBJECT OF INTEREST'S"
365      PRINT
370       PRINT  TAB(20)"ALTITUDE:  ";H/R1
375       PRINT
380       PRINT  TAB(20) "AZIMUTH:   ";A/R1
385       PRINT :PRINT :PRINT TAB(20)
386       INPUT "ANOTHER Y/N";A$
387       IF A$ = "Y" THEN GOTO 95 ELSE 390
390       END
400   REM   SEXAGESIMAL TO DECIMAL
410   REM
420       S = 1: A1 = ABS(VAL(A$))
430       IF LEFT$(A$,1) = "-" THEN S = -1
440       A = S*(A1+A2/60+A3/3600)
450       RETURN
460  REM
470  REM  GMST AND JD
480  REM
490  REM GMST
500  REM
510  REM
520  GOSUB 710
530   D = J - 2451545!
540   T = D/36525!: T1 = INT(T)
550   J0 = T1*36525! + 2451545!
560   T2 = (J-J0+.5)/36525!
570   S = 24110.54841# + 184.812866#*T1
580   S = S+8640184.812866#*T2
590   S = S+.093104*T*T
600   S = S-.0000062 *T*T*T
610   S = S/86400!: S = S - INT(S)
620   S = 24*(S+(F - .5)*1.002737909#)
630   IF S<0 THEN S = S+24
640   IF S>24 THEN S = S-24
650  ST = S
660   H = INT(S): M1 = 60 *(S-H)
670   M = INT(M1): SS = 60*(M1 - M)
675   PRINT
680    PRINT TAB(20)  "GMST;  ";H;M;SS
681  PRINT
685    GOTO 135
690  END
700  REM
710  REM   CALENDAR --> JD
720  REM
730  PRINT TAB(20):  INPUT "YEAR, MONTH, DAY ";Y,M,D
735  PRINT
740  PRINT TAB(15) : INPUT "JULIAN (0) OR GREGORIAN CALENDAR (1) ";G
750  D1=INT(D): F=D-D1-.5
760  J=-INT(7*(INT((M+9)/12)+Y)/4)
770  IF G=0 THEN 810
780  S=SGN(M-9): A=ABS(M-9)
790  J1=INT(Y+S*INT(A/7))
800  J1=-INT((INT(J1/100)+1)*3/4)
810  J=J+INT(275*M/9)+D1+G*J1
820  J=J+1721027!+2*G+367*Y
830  IF F>=0 THEN 850
840  F=F+1: J=J-1
850  PRINT : PRINT TAB(20) "JULIAN DAY : ";J;F
860  RETURN
