100 'Credit Card ("CREDITCARD")
110 CLS
120 COLOR 0,15 : PRINT "Credit Card" : COLOR 15,0
130 DEFDBL A-Z
140 MONEYFMT$ = "$$##,###,###.##"
150 PRINT : PRINT
160 PRINT "Do not enter dollar signs or commas"
170 PRINT
180 INPUT "Monthly purchases: ", PURCHASES
190 INPUT "Cash discount (in percent): ", DISCOUNT
200 INPUT "Annual credit card fee: ", FEE
210 INPUT "Annual interest rate (in percent): ", AR
220 '     Find daily interest rate
230 DR = (1 + AR / 100) ^ (1/360) - 1
240 '     Find monthly interest rate
250 PR = (1 + AR / 100) ^ (1/12) - 1
260 '     Calculate present value of cash expenditures
270 FCASH = (1 - (1 + DR) ^  -360) * (1 - DISCOUNT / 100) / (30 * DR)
280 PVCASH = PURCHASES * FCASH
290 '     Calculate present value of credit card purchases
300 FCARD = ( (1 - (1 + PR) ^  -12) / PR) / (1 + PR)
310 PVCARD = FEE + PURCHASES * FCARD
320 '     Minimum monthly purchase to make credit card worthwhile
330 BREAKEVEN = FEE / (FCASH - FCARD)
340 PRINT
350 PRINT "Cash cost: "; TAB(30); USING MONEYFMT$; PVCASH
360 PRINT "Credit card cost: "; TAB(30); USING MONEYFMT$; PVCARD
370 PRINT "Breakeven charge: "; TAB(30);
380 IF BREAKEVEN >= 0 THEN PRINT USING MONEYFMT$; BREAKEVEN                                           ELSE PRINT SPC(10); "Never"
390 PRINT "Saving in using credit card: "; TAB(30); USING MONEYFMT$;                      PVCASH - PVCARD
400 END
