           CHURCH BOOKS - CHART OF ACCOUNTS

NOTE:  This chart of account is designed to cover the categories of income and 
   outgo for a church. 
   
   IMPORTANT: The monthly account summaries printed out by the "CHURCH BOOKS" 
   program will be by the catagories that have account numbers inside brackets.  
   You should not change these ranges without having us modify your program.  
   
   We suggest you assign individual account numbers for individual categories 
   within these broad ranges.  (A few hypothetical accounts are included for 
   example purposes).  Account numbers go from .01 to 999.99 with each number 
   having two places to the right of the decimal point if needed.  (Most of the 
   time the places to the right will not be used).  This gives a lot of 
   flexability.  For example, you could have one number for sunday school 
   materials and use the numbers right of the decimal to designate different 
   suppliers.  You may alter any account name or number that is not in 
   parenthesis and of course add your own accounts within these ranges.  The 
   output is designed so that the non-accountant will understand it.  The 
   monthly report will print out all deposits and checks in order by account 
   numbers within the respective categories.  If a more detailed financial 
   statement is desired, the special reports option may be used for reports on 
   specific accounts (or ranges of accounts).  The results of the financial 
   statement produced by this program plus information from the special reports 
   can be moved to a spreadsheet program where you can manipulate the numbers 
   to produce a report that conforms to your particular needs.  

   It should be noted that freedom is given to include some items either within 
   the budget or as non-budget items.  A value judgement will need to be made 
   when a designated contribution is made as to whether it is for a need within 
   or outside of the budget.  But you need to be consistant.  If you use an 
   account number for a non-budget designated contribution, be sure the 
   expenditure is also "non-budget."  A good example would be for a special 
   speaker.  You could choose to enter the contributions and outgo as either 
   budget or non-budget.  The program gives you the option.

   As we get feedback from individual churches we are open to modifying this 
   chart of accounts.  It is probable that in time we will have several 
   variations available.  We do value your suggestions.  If your church has 
   particular needs, we will modify it to meet those needs.
   

I. CONTRIBUTIONS  (ACCOUNT NUMBERS 1 - 109.99)

     A. UNDESIGNATED CONTRIBUTIONS  (1 - 39.99)

        1. SUNDAY MORNING OFFERINGS
             FIRST SUNDAY ----------------------------------------  11
             SECOND SUNDAY ---------------------------------------  12
             THIRD SUNDAY ----------------------------------------  13
             FOURTH SUNDAY ---------------------------------------  14
             FIFTH SUNDAY ----------------------------------------  15
        2. SUNDAY EVENING OFFERINGS 
             FIRST SUNDAY ----------------------------------------  21
             SECOND SUNDAY ---------------------------------------  22
             THIRD SUNDAY ----------------------------------------  23
             FOURTH SUNDAY ---------------------------------------  24
             FIFTH SUNDAY ----------------------------------------  25
        3. OTHER GENERAL OFFERINGS -------------------------------  30
    

     B. DESIGNATED CONTRIBUTIONS (40 - 109.99)
   
        1. INTERNAL PROJECTS Budget items (40 - 54.99)
        2. INTERNAL PROJECTS Non-Budget items (55 - 69.99)
             BUILDING FUND ---------------------------------------  55
        3. EXTERNAL PROJECTS (70 - 109.99)
             MISSIONS --------------------------------------------  71
             SPECIAL SPEAKERS ------------------------------------  91
             BENEVOLENCE ----------------------------------------- 101
   

II. OTHER SOURCES OF INCOME  (ACCOUNT NUMBERS 110 - 199.99)

     A. INVESTMENT INCOME    (110 - 129.99)
        1. INTEREST ON SAVINGS ACCOUNTS -------------------------- 110
        2. DIVIDENDS FROM OTHER INVESTMENTS ---------------------- 120

     B. SALE OF CHURCH ASSETS  (130 - 149.99)
       
     C. CHURCH BORROWING  (150 - 159.99)
        1. FROM MEMBERS ------------------------------------------ 130
        2. FROM DENOMINATIONAL SOURCES --------------------------- 140
        3. FROM BANKS -------------------------------------------- 150

     D. REPAYMENT OF LOANS BY CHURCH  (160 - 179.99)
        1. REPAYMENT OF LOANS ------------------------------------ 160
        
     E. TRANSFER FROM OTHER CHURCH ACCOUNTS (180 - 189.99)

     F. MISCELLANEOUS (190 - 199.99)



III. GENERAL CHURCH EXPENSES  (ACCOUNT NUMBERS 200 - 399.99)

     A. ADVERTISING EXPENSES  (200 - 239.99)
        1. NEWSPAPERS  200 - 209.99
             THE BRYAN/COLLEGE STATION EAGLE -------------------- 201
             THE PRESS ------------------------------------------ 202
        2. RADIO  210 - 219.99
             KTAM/KORA ------------------------------------------ 210
             KYSS/KAGE ------------------------------------------ 212
        3. OTHER ADVERTISING  220 - 239.99
   
     B. COMMUNICATIONS (240 - 269.99)
         GENERAL TELEPHONE -------------------------------------- 250
         MCI ---------------------------------------------------- 260
   
     C. CHURCH PROPERTY OCCUPANCY (270 - 299.99)
         MORTGAGE PAYMENTS -------------------------------------- 270
         UTILITY PAYMENTS --------------------------------------- 280
         REPAIRS & MAINTENANCE ---------------------------------- 290
   
     D. GENERAL OPERATION EXPENSES (300 - 399.99)
         BANK SERVICE CHARGES ---------------------------------- (301)
            INSURANCE 
             HAZZARD -------------------------------------------- 310
             LIABILITY ------------------------------------------ 315
         INTEREST EXPENSE --------------------------------------- 320
         KITCHEN EXPENSES --------------------------------------- 322
         LEGAL AND ACCOUNTING ----------------------------------- 325
         OFFICE REFRESMENTS ------------------------------------- 330
         OFFICE SUPPLIES ---------------------------------------- 340
         PETTY CASH --------------------------------------------- 350
         POSTAGE ------------------------------------------------ 358
         PRINTING ----------------------------------------------- 362
         SUBSCRIPTIONS ------------------------------------------ 370
         TAXES -------------------------------------------------- 380
  
IV. PERSONNEL EXPENSES (400 - 499.99)
     
     A.  MINISTERIAL STAFF (400 - 429.99)
            SENIOR PASTOR
               SALARY ------------------------------------------- 401.0
               HOUSING ALLOWANCE -------------------------------- 401.2
               TRANSPORTATION ----------------------------------- 401.4
     
     B. ADMINISTRATIVE STAFF (430 - 459.99)
     
     C. PAYROLL TAXES (460 - 469.99)
   
     D. PENSIONS & RETIREMENT (470 - 479.99)

     E. TRAVEL AND CONVENTIONS (480 - 499.99)

V. MINISTRY EXPENSES  (500 - 699.99)

     A. CHRISTIAN EDUCATION (500 - 549.99)
         1. SUNDAY SCHOOL SUPPLIES 500 - 519.99
         2. VACATION BIBLE SCHOOL  520 - 529.99
     B. FELLOWSHIP & ENTERTAINMENT (550 - 559.99)
     C. NURSERY EXPENSES  (560 - 569.99)
     D. MUSIC MINISTRY (570 - 579.99)
     E. RADIO, TELEVISION & TAPES (580 - 599.99)
     F. SPECIAL SPEAKERS (600 - 619.99)
     G. TRAINNING UNION (620 - 629.99)
     H. WORSHIP EXPENSES (630 - 639.99)
     H. YOUTH DEPARTMENT (640 - 649.99)
     I. MISCELLANEOUS (650 - 699.99)

       
VI. MISSIONS  (700 - 799.99)
     
     A. CHUCH RELATED MISSIONS (700 - 709.99)
          FOREIGN MISSIONS
          HOME MISSIONS
     B. INDEPENDENT MISSIONS (710 - 749.99)
     C. DESIGNATED MISSION GIVING (750 - 799.99)
   
VII. BENEVOLENCE  (800 - 899.99)
     
     A. CHURCH GIVING TO THE NEEDY  (800 - 824.99)
     B. DESIGNATED GIVING TO NEEDY (825 - 849.99)
     C. OTHER BENEVOLENT AGENCIES (850 - 899.99)
       

IX. MISCELLANEOUS EXPENDITURES

     A. NON-BUDGET CHURCH PROJECTS (900 - 929.99)
   
     B. PURCHASES OF PROPERTY AND EQUIPMENT  (930 - 949.99)
   
        REAL PROPERTY 930 - 934.99
        EQUIPMENT & MISC 935 - 939.99
        OFFICE EQUIPMENT --------------------------------------- 835
        OTHER EQUIPMENT ---------------------------------------- 836
        MISC. -------------------------------------------------- 837
        LIBRARY 940 - 949.99



     C. TRANSFER OF FUNDS TO OTHER CHURCH ACCOUNTS  (950 - 959.99)
       
        BUILDING FUND ------------------------------------------ 952
        SAVINGS ACCOUNT ---------------------------------------- 955
   

     D. REPAYMENT OF LOANS  (960 - 974.99)
    

     E. LOANED BY CHURCH  (975 - 989.99)
   

     F. MISCELLANEOUS  (990 - 999.99)

