10 DEF FNHM(X)=SGN(X)*(INT(ABS(X)/100)+(ABS(X) MOD 100)/60)
20 DIM RA(600),DEC(600),MAG(600),ED(12)
30 PI=3.14159:RADIAN=PI/180
40 GOSUB 870
50 SCREEN 0:WIDTH 80:COLOR 7,0,0:CLS
60 PRINT"1.  Map any area of the sky"
70 PRINT"2.  Generate star map for any date"
80 PRINT"3.  Quit"
90 INPUT"Your choice";YC
100 IF YC<>1 AND YC<>2 AND YC<>3 THEN 90
110 IF YC=3 THEN CLS:END
120 PRINT
130 IF YC=2 THEN 260
140 INPUT"Enter RA of the field center in format HHMM";RA0
150 RA0=FNHM(RA0)
160 INPUT"Enter DEC of the field center in format DDMM";DEC0
170 DEC0=FNHM(DEC0)
180 INPUT"Enter field width in degrees";WID
190 INPUT"Mark the above RA and DEC";MAR$
200 MAR$=LEFT$(MAR$,1):MAR=(MAR$="Y" OR MAR$="y")
210 INPUT"Do you want a line around the map";LIN$
220 LIN$=LEFT$(LIN$,1):LIN=(LIN$="Y" OR LIN$="y")
230 INPUT"Do you want BEEPs for stars";BP$
240 BP$=LEFT$(BP$,1):BP=(BP$="Y" OR BP$="y")
250 CIR=0:GOSUB 510:GOTO 50
260 INPUT"Enter latitude in format DDMM (- for south, + for north)";LAT
270 LAT=FNHM(LAT)
280 INPUT"Enter longitude in format DDMM (- for west, + for east)";LONG
290 EW=SGN(LONG):LONG=ABS(LONG):LD=INT(LONG/100):LM=LONG MOD 100
300 INPUT"Enter date in format MM-DD-YY";DAT$
310 MM=VAL(MID$(DAT$,1,2)):DD=VAL(MID$(DAT$,4,2)):YY=VAL(MID$(DAT$,7,2))
320 INPUT"Enter time in format HHMM ZONE";TIM$
330 H=VAL(LEFT$(TIM$,2)):M=VAL(MID$(TIM$,3,2)):Z$=MID$(TIM$,6)
340 FOR CPS=1 TO LEN(Z$):IF MID$(Z$,CPS,1)>="a" AND MID$(Z$,CPS,1)<="z" THEN MID$(Z$,CPS,1)=CHR$(ASC(MID$(Z$,CPS,1))-32)
350 NEXT CPS
355 PRINT Z$:STOP
360 G=0:IF Z$="UT" OR Z$="GMT" THEN 390
370 A$=MID$(Z$,1,1):IF A$="E" THEN G=G+5 ELSE IF A$="C" THEN G=G+6 ELSE IF A$="M" THEN G=G+7 ELSE IF A$="P" THEN G=G+8
380 IF MID$(Z$,2,1)="D" THEN G=G-1
390 LC=240*LD+4*LM:SG=ED(MM)
400 SD=SG+EW*LC:IF SD<0 THEN SD=SD+86400!
410 SL=SD-EW*G*3600+G*9.856459:IF SL<0 THEN SL=SL+86400!
420 DA=DD*236.555
430 HA=H*3600+H*9.856459
440 MA=M*60+M*.164274
450 SD=(SL+DA+HA+MA+.5)/3600
460 IF SD>24 THEN SD=SD-24:GOTO 460
470 INPUT"Do you want BEEPs for stars";BP$
480 BP$=LEFT$(BP$,1):BP=(BP$="Y" OR BP$="y")
490 RA0=SD:DEC0=LAT:LIN=0:MAR=0:WID=230
500 CIR=-1:GOSUB 510:GOTO 50
510 'Star plot routine
520 INPUT"High or Low resolution";RES$
530 IF LEFT$(RES$,1)="H" THEN SCR=2:SX=640:SY=200:YHT=.38 ELSE SCR=1:SX=320:SY=200:YHT=.76
540 CENTX=SX/2:CENTY=SY/2
550 R=SX*53/WID:LAM0=.261845*RA0:PHI0=DEC0*RADIAN
560 CLS:SCREEN SCR:KEY OFF
570 IF LIN THEN LINE(0,0)-(SX-1,SY-1),,B
580 IF MAR THEN CIRCLE(CENTX,CENTY),SCR+1
590 IF CIR THEN CIRCLE(CENTX,CENTY),119*SCR
600 FOR J%=0 TO NUM%-1
610 '-------Plot each star here------
620 PHI=DEC(J%):MAG=MAG(J%):DLAM=RA(J%)-LAM0
630 A=SIN(PHI0):B=COS(PHI0)
640 C=SIN(PHI):D=COS(PHI)
650 E=SIN(DLAM):F=COS(DLAM)
660 K0=2/(1+A*C+B*D*F)
670 X=R*K0*D*E:Y=R*K0*(B*C-A*D*F)
680 X=CENTX-X:Y=CENTY-YHT*Y
690 IF X>SX OR X<0 THEN 780
700 IF Y<0 OR Y>SY THEN 780
710 PSET(X,Y)
720 IF MAG<=3 THEN PSET(X+1,Y)
730 IF MAG<=2.33 THEN PSET(X+1,Y-1):PSET(X+2,Y):PSET(X+1,Y+1)
740 IF MAG<=1.66 THEN PSET(X+2,Y-1):PSET(X+3,Y):PSET(X+2,Y+1)
750 IF MAG<=1 THEN PSET(X+3,Y-1):PSET(X+4,Y):PSET(X+3,Y+1):PSET(X+2,Y-2):PSET(X+2,Y+2)
760 IF MAG>5 THEN MAG=5
770 IF BP THEN SOUND(512-64*MAG),1
780 K$=INKEY$:IF K$=CHR$(27) THEN 800
790 NEXT J%
800 BEEP:BEEP
810 IF CIR THEN LINE(0,0)-(SX,0),0:PAINT(0,0),5-2*SCR,5-2*SCR:PAINT(0,0),0,0:LOCATE 1,1:PRINT DAT$:PRINT TIM$
820 IF CIR THEN PRINT:PRINT"N":PRINT"":PRINT" W"
830 IF CIR THEN CIRCLE(CENTX,CENTY),119*SCR
840 K$=INPUT$(1)
850 IF K$=CHR$(27) THEN END
860 RETURN
870 '-------Load star array-------
880 CLS:COLOR 15
890 PRINT"                               Star --- Ver. 1.0"
900 PRINT"                           by Alan Farmer, July 1985"
910 PRINT
920 PRINT"          This is a user-supported program.   Feel free to make copies"
930 PRINT"          and pass them out, but  please  do not sell them.  Donations"
940 PRINT"          of about $5 would be greatly appreciated.   Please send your"
950 PRINT"          questions,  comments,  criticisms,  improved star data,  and"
960 PRINT"          DONATIONS to:"
970 PRINT
980 PRINT"                           Alan Farmer"
990 PRINT"                           2743 McElroy Drive"
1000 PRINT"                           Charlottesville, Va  22903"
1010 FOR I=1 TO 12:READ A,B,C:ED(I)=3600*A+60*B+C-236.555
1020 IF ED(I)=<0 THEN ED(I)=ED(I)+86400!
1030 NEXT I
1040 DATA 6,39,23,8,41,36,10,35,56,12,38,9,14,36,26,16,38,39
1050 DATA 18,36,56,20,39,9,22,41,22,0,39,39,2,41,52,4,40,9
1060 OPEN "star.dat" FOR INPUT AS #1:K%=0
1070 IF EOF(1) THEN CLOSE:NUM%=K%-1:ARLD=-1:BEEP:BEEP:RETURN
1080 INPUT #1,N$
1090 IF LEFT$(N$,1)="*" THEN 1070
1100 RA=VAL(LEFT$(N$,2))+VAL(MID$(N$,3,2))/60
1110 DSGN$=MID$(N$,6,1):IF DSGN$="-" THEN DSGN=-1 ELSE DSGN=1
1120 DEC=VAL(MID$(N$,7,2))+VAL(MID$(N$,9,2))/60
1130 DEC=DSGN*DEC:MAG=VAL(MID$(N$,12))
1140 RA(K%)=.2618*RA:DEC(K%)=DEC*RADIAN:MAG(K%)=MAG
1150 K%=K%+1:GOTO 1070
