INTERRUPTS	SEGMENT AT 0H
	ORG	13H*4
DISK_INT	LABEL	DWORD
INTERRUPTS	ENDS
 
SCREEN	SEGMENT AT 0B000H
SCREEN	ENDS
CODE_SEG	SEGMENT
	ASSUME	CS:CODE_SEG
	ORG	100H
FIRST:	JMP	LOAD_WATCH
 
	MSG_PART_1	DB	'DISK ERROR: '
	MSG_PART_2	DB	'No response Failed Seek NEC Error   '
			DB	'Bad CRC seenDMA overrun Impos sector'
			DB	'No Addr MarkW. ProtectedErr Unknown '
	FIRST_POSITION	DW	?
	FLAGS		DW	?
	SCREEN_SEG_OFFSET	DW	0
	OLD_DISK_INT		DD	?
	RET_ADDR		LABEL DWORD
	RET_ADDR_WORD		DW 2 DUP(?)
 
DISK_WATCH	PROC	FAR
	ASSUME	CS:CODE_SEG
	PUSHF
	CALL	OLD_DISK_INT
	PUSHF
	POP	FLAGS
	JC	ERROR
	JMP	FIN
ERROR:	PUSH	AX
	PUSH	CX
	PUSH	DX
	PUSH	DI
	PUSH	SI
	PUSH	ES
	LEA	SI,MSG_PART_1
	ASSUME	ES:SCREEN
	MOV	DX,SCREEN
	MOV	ES,DX
	MOV	DI,SCREEN_SEG_OFFSET
	ADD	DI,FIRST_POSITION
	CALL	WRITE_TO_SCREEN
	MOV	DH,80H
	MOV	CX,7
E_LOOP:	CMP	AH,DH
	JE	E_FOUND
	ADD	SI,12
	SHR	DH,1
	LOOP	E_LOOP
	CMP	AH,3
	JE	E_FOUND
	ADD	SI,12
E_FOUND:CALL 	WRITE_TO_SCREEN
	POP	ES
	POP	SI
	POP	DI
	POP	DX
	POP	CX
	POP	AX
FIN:	POP	RET_ADDR_WORD
	POP	RET_ADDR_WORD[2]
	ADD	SP,2
	PUSH	FLAGS
	POPF
	JMP	RET_ADDR
DISK_WATCH	ENDP
 
WRITE_TO_SCREEN	PROC	NEAR
	MOV	CX,12
W_LOOP:	MOVS	ES:BYTE PTR[DI],CS:[SI]
	MOV	AL,7
	MOV	ES:[DI],AL
	INC	DI
	LOOP	W_LOOP
	RET
WRITE_TO_SCREEN	ENDP
LOAD_WATCH	PROC	NEAR
	ASSUME	DS:INTERRUPTS
	MOV	AX,INTERRUPTS
	MOV	DS,AX
 
	MOV	AX,DISK_INT
	MOV	OLD_DISK_INT,AX
	MOV	AX,DISK_INT[2]
	MOV	OLD_DISK_INT[2],AX
 
	MOV	DISK_INT,OFFSET DISK_WATCH
	MOV	DISK_INT[2],CS
 
	MOV	AH,15
	INT	10H
	SUB	AH,25
	SHL	AH,1
	MOV	BYTE PTR FIRST_POSITION,AH
	TEST	AL,4
	JNZ	EXIT
	MOV	SCREEN_SEG_OFFSET,8000H
EXIT:MOV	DX,OFFSET LOAD_WATCH
	INT	27H
LOAD_WATCH	ENDP
	CODE_SEG	ENDS
	END	FIRST
